]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
New function to update changelog from git.
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.3-test"
28 GIT_BRANCH=master:master # Version number
29 SLOGAN="www.ipfire.org" # Software slogan
30 CONFIG_ROOT=/var/ipfire # Configuration rootdir
31 NICE=10 # Nice level
32 MAX_RETRIES=1 # prefetch/check loop
33 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
34 MACHINE=`uname -m`
35 GIT_TAG=$(git tag | tail -1)
36
37 IPFVER="full" # Which versions should be compiled? (full|devel)
38
39 # Debian specific settings
40 if [ ! -e /etc/debian_version ]; then
41 FULLPATH=`which $0`
42 else
43 if [ -x /usr/bin/realpath ]; then
44 FULLPATH=`/usr/bin/realpath $0`
45 else
46 echo "ERROR: Need to do apt-get install realpath"
47 exit 1
48 fi
49 fi
50
51 PWD=`pwd`
52 BASENAME=`basename $0`
53 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
54 LOGFILE=$BASEDIR/log/_build.preparation.log
55 export BASEDIR LOGFILE
56 DIR_CHK=$BASEDIR/cache/check
57 mkdir $BASEDIR/log/ 2>/dev/null
58
59 # Include funtions
60 . tools/make-functions
61
62 if [ -f .config ]; then
63 . .config
64 else
65 echo -e "${BOLD}No configuration found!${NORMAL}"
66 echo -ne "Do you want to create one (y/N)?"
67 read CREATE_CONFIG
68 echo ""
69 if [ "$CREATE_CONFIG" == "y" ]; then
70 make_config
71 fi
72 fi
73
74 if [ -z $EDITOR ]; then
75 for i in nano emacs vi; do
76 EDITOR=$(which $i 2>/dev/null)
77 if ! [ -z $EDITOR ]; then
78 export EDITOR=$EDITOR
79 break
80 fi
81 done
82 [ -z $EDITOR ] && exiterror "You should have installed an editor."
83 fi
84
85 prepareenv() {
86 ############################################################################
87 # #
88 # Are we running the right shell? #
89 # #
90 ############################################################################
91 if [ ! "$BASH" ]; then
92 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
93 fi
94
95 if [ -z "${BASH_VERSION}" ]; then
96 exiterror "Not running BASH shell."
97 fi
98
99
100 ############################################################################
101 # #
102 # Trap on emergency exit #
103 # #
104 ############################################################################
105 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
106
107
108 ############################################################################
109 # #
110 # Resetting our nice level #
111 # #
112 ############################################################################
113 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
114 renice $NICE $$ > /dev/null
115 if [ `nice` != "$NICE" ]; then
116 beautify message FAIL
117 exiterror "Failed to set correct nice level"
118 else
119 beautify message DONE
120 fi
121
122
123 ############################################################################
124 # #
125 # Checking if running as root user #
126 # #
127 ############################################################################
128 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
129 if [ `id -u` != 0 ]; then
130 beautify message FAIL
131 exiterror "Not building as root"
132 else
133 beautify message DONE
134 fi
135
136
137 ############################################################################
138 # #
139 # Checking for necessary temporary space #
140 # #
141 ############################################################################
142 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
143 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
144 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
145 if (( 2048000 > $BASE_ASPACE )); then
146 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
147 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
148 beautify message FAIL
149 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
150 fi
151 else
152 beautify message DONE
153 fi
154
155 ############################################################################
156 # #
157 # Building Linux From Scratch system #
158 # #
159 ############################################################################
160 # Set umask
161 umask 022
162
163 # Set LFS Directory
164 LFS=$BASEDIR/build
165
166 # Check /tools symlink
167 if [ -h /tools ]; then
168 rm -f /tools
169 fi
170 if [ ! -a /tools ]; then
171 ln -s $BASEDIR/build/tools /
172 fi
173 if [ ! -h /tools ]; then
174 exiterror "Could not create /tools symbolic link."
175 fi
176
177 # Setup environment
178 set +h
179 LC_ALL=POSIX
180 MAKETUNING="-j6"
181 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
182 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
183
184 # Make some extra directories
185 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
186 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
187 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
188 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
189
190 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
191 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
192
193 # Make all sources and proc available under lfs build
194 mount --bind /dev $BASEDIR/build/dev
195 mount --bind /dev/pts $BASEDIR/build/dev/pts
196 mount --bind /dev/shm $BASEDIR/build/dev/shm
197 mount --bind /proc $BASEDIR/build/proc
198 mount --bind /sys $BASEDIR/build/sys
199 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
200 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
201 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
202 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
203 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
204 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
205 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
206 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
207 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
208
209 # This is a temporary hack!!!
210 if [ ! -f /tools/bin/hostname ]; then
211 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
212 fi
213
214 # Run LFS static binary creation scripts one by one
215 export CCACHE_DIR=$BASEDIR/ccache
216 export CCACHE_HASHDIR=1
217
218 # Remove pre-install list of installed files in case user erase some files before rebuild
219 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
220 }
221
222 buildtoolchain() {
223 LOGFILE="$BASEDIR/log/_build.toolchain.log"
224 export LOGFILE
225 ORG_PATH=$PATH
226 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
227 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
228 lfsmake1 ccache
229 lfsmake1 binutils PASS=1
230 lfsmake1 gcc PASS=1
231 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
232 lfsmake1 linux-libc-header
233 lfsmake1 glibc
234 lfsmake1 cleanup-toolchain PASS=1
235 lfsmake1 tcl
236 lfsmake1 expect
237 lfsmake1 dejagnu
238 lfsmake1 gcc PASS=2
239 lfsmake1 binutils PASS=2
240 lfsmake1 ncurses
241 lfsmake1 bash
242 lfsmake1 bzip2
243 lfsmake1 coreutils
244 lfsmake1 diffutils
245 lfsmake1 findutils
246 lfsmake1 gawk
247 lfsmake1 gettext
248 lfsmake1 grep
249 lfsmake1 gzip
250 lfsmake1 m4
251 lfsmake1 make
252 lfsmake1 patch
253 lfsmake1 perl
254 lfsmake1 sed
255 lfsmake1 tar
256 lfsmake1 texinfo
257 lfsmake1 util-linux
258 lfsmake1 cleanup-toolchain PASS=2
259 export PATH=$ORG_PATH
260 }
261
262 buildbase() {
263 LOGFILE="$BASEDIR/log/_build.base.log"
264 export LOGFILE
265 lfsmake2 stage2
266 lfsmake2 linux-libc-header
267 lfsmake2 man-pages
268 lfsmake2 glibc
269 lfsmake2 cleanup-toolchain PASS=3
270 lfsmake2 binutils
271 lfsmake2 gcc
272 lfsmake2 berkeley
273 lfsmake2 coreutils
274 lfsmake2 iana-etc
275 lfsmake2 m4
276 lfsmake2 bison
277 lfsmake2 ncurses
278 lfsmake2 procps
279 lfsmake2 sed
280 lfsmake2 libtool
281 lfsmake2 perl
282 lfsmake2 readline
283 lfsmake2 zlib
284 lfsmake2 autoconf
285 lfsmake2 automake
286 lfsmake2 bash
287 lfsmake2 bzip2
288 lfsmake2 diffutils
289 lfsmake2 e2fsprogs
290 lfsmake2 ed
291 lfsmake2 file
292 lfsmake2 findutils
293 lfsmake2 flex
294 lfsmake2 gawk
295 lfsmake2 gettext
296 lfsmake2 grep
297 lfsmake2 groff
298 lfsmake2 gzip
299 lfsmake2 inetutils
300 lfsmake2 iproute2
301 lfsmake2 kbd
302 lfsmake2 less
303 lfsmake2 libaal
304 lfsmake2 make
305 lfsmake2 man
306 lfsmake2 mktemp
307 lfsmake2 modutils
308 lfsmake2 mtd
309 lfsmake2 net-tools
310 lfsmake2 patch
311 lfsmake2 psmisc
312 lfsmake2 reiser4progs
313 lfsmake2 shadow
314 lfsmake2 sysklogd
315 lfsmake2 sysvinit
316 lfsmake2 tar
317 lfsmake2 texinfo
318 lfsmake2 udev
319 lfsmake2 util-linux
320 lfsmake2 vim
321 lfsmake2 grub
322 }
323
324 buildipfire() {
325 LOGFILE="$BASEDIR/log/_build.ipfire.log"
326 export LOGFILE
327 ipfiremake configroot
328 ipfiremake backup
329 ipfiremake dhcp
330 ipfiremake dhcpcd
331 ipfiremake libusb
332 ipfiremake libpcap
333 ipfiremake ppp
334 ipfiremake rp-pppoe
335 ipfiremake unzip
336 ipfiremake linux SMP=1
337 # ipfiremake linux-fusion SMP=1
338 # ipfiremake ipp2p SMP=1
339 # ipfiremake r8169 SMP=1
340 # ipfiremake r8168 SMP=1
341 # ipfiremake atl1 SMP=1
342 ipfiremake atl2 SMP=1
343 ipfiremake kqemu SMP=1
344 ipfiremake v4l-dvb SMP=1
345 ipfiremake madwifi SMP=1
346 ipfiremake sane KMOD=1 SMP=1
347 ipfiremake linux
348 # ipfiremake linux-fusion
349 # ipfiremake ipp2p
350 # ipfiremake r8169
351 # ipfiremake r8168
352 # ipfiremake atl1
353 ipfiremake atl2
354 ipfiremake kqemu
355 ipfiremake v4l-dvb
356 ipfiremake madwifi
357 ipfiremake sane KMOD=1
358 ipfiremake pkg-config
359 ipfiremake linux-atm
360 ipfiremake cpio
361 ipfiremake klibc
362 ipfiremake mkinitcpio
363 ipfiremake udev KLIBC=1
364 ipfiremake expat
365 ipfiremake gdbm
366 ipfiremake gmp
367 ipfiremake pam
368 ipfiremake openssl
369 ipfiremake curl
370 ipfiremake python
371 ipfiremake libnet
372 ipfiremake libidn
373 ipfiremake libjpeg
374 ipfiremake libpng
375 ipfiremake libtiff
376 ipfiremake libart
377 ipfiremake freetype
378 ipfiremake gd
379 ipfiremake popt
380 ipfiremake pcre
381 ipfiremake slang
382 ipfiremake newt
383 ipfiremake libcap
384 ipfiremake pciutils
385 ipfiremake usbutils
386 ipfiremake libxml2
387 ipfiremake libxslt
388 ipfiremake BerkeleyDB
389 ipfiremake mysql
390 ipfiremake cyrus-sasl
391 ipfiremake openldap
392 ipfiremake apache2
393 ipfiremake php
394 ipfiremake apache2 PASS=C
395 ipfiremake arping
396 ipfiremake beep
397 ipfiremake bind
398 ipfiremake cdrtools
399 ipfiremake dnsmasq
400 ipfiremake dosfstools
401 ipfiremake squashfstools
402 ipfiremake reiserfsprogs
403 ipfiremake xfsprogs
404 ipfiremake sysfsutils
405 ipfiremake fuse
406 ipfiremake ntfs-3g
407 ipfiremake ethtool
408 ipfiremake ez-ipupdate
409 ipfiremake fcron
410 ipfiremake perl-GD
411 ipfiremake GD-Graph
412 ipfiremake GD-TextUtil
413 ipfiremake gnupg
414 ipfiremake hdparm
415 ipfiremake sdparm
416 ipfiremake mtools
417 ipfiremake initscripts
418 ipfiremake whatmask
419 ipfiremake iptables
420 ipfiremake libupnp
421 # ipfiremake ipp2p IPT=1
422 ipfiremake linux-igd
423 ipfiremake ipaddr
424 ipfiremake iptstate
425 ipfiremake iputils
426 ipfiremake l7-protocols
427 ipfiremake mISDN
428 ipfiremake capi4k-utils
429 ipfiremake hwdata
430 ipfiremake kudzu
431 ipfiremake logrotate
432 ipfiremake logwatch
433 ipfiremake misc-progs
434 ipfiremake nano
435 ipfiremake nasm
436 ipfiremake URI
437 ipfiremake HTML-Tagset
438 ipfiremake HTML-Parser
439 ipfiremake Compress-Zlib
440 ipfiremake Digest
441 ipfiremake Digest-SHA1
442 ipfiremake Digest-HMAC
443 ipfiremake libwww-perl
444 ipfiremake Net-DNS
445 ipfiremake Net-IPv4Addr
446 ipfiremake Net_SSLeay
447 ipfiremake IO-Stringy
448 ipfiremake Unix-Syslog
449 ipfiremake Mail-Tools
450 ipfiremake MIME-Tools
451 ipfiremake Net-Server
452 ipfiremake Convert-TNEF
453 ipfiremake Convert-UUlib
454 ipfiremake Archive-Tar
455 ipfiremake Archive-Zip
456 ipfiremake Text-Tabs+Wrap
457 ipfiremake Locale-Country
458 ipfiremake XML-Parser
459 ipfiremake glib
460 ipfiremake GeoIP
461 ipfiremake fwhits
462 ipfiremake noip_updater
463 ipfiremake ntp
464 ipfiremake openssh
465 ipfiremake rrdtool
466 ipfiremake setserial
467 ipfiremake setup
468 ipfiremake snort
469 ipfiremake oinkmaster
470 ipfiremake squid
471 ipfiremake squid-graph
472 ipfiremake squidguard
473 ipfiremake calamaris
474 ipfiremake tcpdump
475 ipfiremake traceroute
476 ipfiremake vlan
477 ipfiremake wireless
478 ipfiremake libsafe
479 ipfiremake pakfire
480 ipfiremake java
481 ipfiremake spandsp
482 ipfiremake lzo
483 ipfiremake openvpn
484 ipfiremake pammysql
485 ipfiremake cups
486 ipfiremake ghostscript
487 ipfiremake foomatic
488 ipfiremake hplip
489 ipfiremake samba
490 ipfiremake sudo
491 ipfiremake mc
492 ipfiremake wget
493 ipfiremake bridge-utils
494 ipfiremake screen
495 ipfiremake hddtemp
496 ipfiremake smartmontools
497 ipfiremake htop
498 ipfiremake postfix
499 ipfiremake fetchmail
500 ipfiremake cyrus-imapd
501 ipfiremake openmailadmin
502 ipfiremake clamav
503 ipfiremake spamassassin
504 ipfiremake amavisd
505 ipfiremake alsa
506 ipfiremake mpg123
507 ipfiremake mpfire
508 ipfiremake guardian
509 ipfiremake libid3tag
510 ipfiremake libmad
511 ipfiremake libogg
512 ipfiremake libvorbis
513 ipfiremake libdvbpsi
514 ipfiremake lame
515 ipfiremake sox
516 ipfiremake libshout
517 ipfiremake icecast
518 ipfiremake icegenerator
519 ipfiremake mpd
520 ipfiremake mpc
521 ipfiremake xvid
522 ipfiremake libmpeg2
523 ipfiremake cmake
524 ipfiremake libpri
525 ipfiremake asterisk
526 ipfiremake gnump3d
527 ipfiremake libsigc++
528 ipfiremake applejuice
529 ipfiremake ocaml
530 ipfiremake mldonkey
531 ipfiremake libtorrent
532 ipfiremake rtorrent
533 ipfiremake ipfireseeder
534 ipfiremake rsync
535 ipfiremake tcpwrapper
536 ipfiremake portmap
537 ipfiremake nfs
538 ipfiremake nmap
539 ipfiremake ncftp
540 ipfiremake etherwake
541 ipfiremake bwm-ng
542 ipfiremake tripwire
543 ipfiremake sysstat
544 ipfiremake vsftpd
545 ipfiremake which
546 ipfiremake openswan
547 ipfiremake lsof
548 ipfiremake centerim
549 ipfiremake br2684ctl
550 ipfiremake pcmciautils
551 ipfiremake lm_sensors
552 ipfiremake collectd
553 ipfiremake lcd4linux
554 ipfiremake neon
555 ipfiremake subversion
556 ipfiremake tcptrack
557 ipfiremake teamspeak
558 ipfiremake elinks
559 ipfiremake igmpproxy
560 ipfiremake fbset
561 ipfiremake sdl
562 ipfiremake qemu
563 ipfiremake sane
564 ipfiremake netpbm
565 ipfiremake phpSANE
566 ipfiremake tunctl
567 ipfiremake nagios
568 ipfiremake ebtables
569 ipfiremake arptables
570 ipfiremake fontconfig
571 ipfiremake freefont
572 ipfiremake directfb
573 ipfiremake dfb++
574 ipfiremake ffmpeg
575 ipfiremake videolan
576 ipfiremake vdr
577 ipfiremake w_scan
578 ipfiremake git
579 ipfiremake squidclamav
580 ipfiremake bc
581 ipfiremake esniper
582 ipfiremake vnstat
583 ipfiremake vnstati
584 ipfiremake wpa_supplicant
585 ipfiremake hostapd
586 ipfiremake urlgrabber
587 ipfiremake syslinux
588 ipfiremake tftp-hpa
589 echo Build on $HOSTNAME > $BASEDIR/build/var/ipfire/firebuild
590 cat /proc/version >> $BASEDIR/build/var/ipfire/firebuild
591 echo >> $BASEDIR/build/var/ipfire/firebuild
592 git log -1 >> $BASEDIR/build/var/ipfire/firebuild
593 echo >> $BASEDIR/build/var/ipfire/firebuild
594 git status >> $BASEDIR/build/var/ipfire/firebuild
595 echo >> $BASEDIR/build/var/ipfire/firebuild
596 cat /proc/cpuinfo >> $BASEDIR/build/var/ipfire/firebuild
597 }
598
599 buildinstaller() {
600 # Run installer scripts one by one
601 LOGFILE="$BASEDIR/log/_build.installer.log"
602 export LOGFILE
603 ipfiremake as86
604 ipfiremake mbr
605 ipfiremake memtest
606 installmake linux-libc-header
607 installmake binutils
608 ipfiremake uClibc PASS=1
609 ipfiremake gcc INST=1
610 installmake uClibc PASS=2
611 installmake gcc INST=2
612 installmake uClibc PASS=3
613 installmake busybox
614 installmake udev
615 installmake slang
616 installmake newt
617 installmake gettext
618 installmake kbd
619 installmake popt
620 installmake sysvinit
621 installmake misc-progs
622 installmake libaal
623 installmake reiser4progs
624 installmake reiserfsprogs
625 installmake sysfsutils
626 installmake util-linux
627 installmake pciutils
628 installmake zlib
629 installmake mtd
630 installmake wget
631 installmake hwdata
632 installmake kudzu
633 installmake pcmciautils
634 installmake installer
635 installmake initrd
636 }
637
638 buildpackages() {
639 LOGFILE="$BASEDIR/log/_build.packages.log"
640 export LOGFILE
641 echo "... see detailed log in _build.*.log files" >> $LOGFILE
642
643 installmake strip
644
645 # Generating list of packages used
646 echo -n "Generating packages list from logs" | tee -a $LOGFILE
647 rm -f $BASEDIR/doc/packages-list
648 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
649 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
650 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
651 fi
652 done
653 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
654 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
655 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
656 rm -f $BASEDIR/doc/packages-list
657 # packages-list.txt is ready to be displayed for wiki page
658 beautify message DONE
659
660 # Update changelog
661 $0 git log
662
663 # Create images for install
664 ipfiremake cdrom ED=full
665
666 # Check if there is a loop device for building in virtual environments
667 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
668 ipfiremake usb-stick
669 fi
670
671 # Create updater package
672 ipfiremake updater
673 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
674
675 ipfirepackages
676
677 # Cleanup
678 stdumount
679 rm -rf $BASEDIR/build/tmp/*
680
681 # Generating total list of files
682 echo -n "Generating files list from logs" | tee -a $LOGFILE
683 rm -f $BASEDIR/log/FILES
684 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
685 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
686 echo "##" >>$BASEDIR/log/FILES
687 echo "## `basename $i`" >>$BASEDIR/log/FILES
688 echo "##" >>$BASEDIR/log/FILES
689 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
690 fi
691 done
692 beautify message DONE
693
694 cd $PWD
695 }
696
697 ipfirepackages() {
698 ipfiremake core-updates
699 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
700 if [ -e $BASEDIR/lfs/$i ]; then
701 ipfiredist $i
702 else
703 echo -n $i
704 beautify message SKIP
705 fi
706 done
707 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
708 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
709 rm -rf $BASEDIR/build/install/packages/*
710 }
711
712 # See what we're supposed to do
713 case "$1" in
714 build)
715 clear
716 BUILDMACHINE=`uname -m`
717 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
718 #only restore on a clean disk
719 if [ ! -f log/cleanup-toolchain-2-tools ]; then
720 if [ ! -n "$PACKAGE" ]; then
721 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
722 prepareenv
723 buildtoolchain
724 else
725 PACKAGENAME=${PACKAGE%.tar.gz}
726 beautify build_stage "Packaged toolchain compilation"
727 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
728 tar zxf $PACKAGE
729 prepareenv
730 else
731 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
732 fi
733 fi
734 else
735 echo -n "Using installed toolchain" | tee -a $LOGFILE
736 beautify message SKIP
737 prepareenv
738 fi
739
740 beautify build_start
741 beautify build_stage "Building LFS"
742 buildbase
743
744 beautify build_stage "Building IPFire"
745 buildipfire
746
747 beautify build_stage "Building installer"
748 buildinstaller
749
750 beautify build_stage "Building packages"
751 buildpackages
752 beautify build_end
753 ;;
754 shell)
755 # enter a shell inside LFS chroot
756 # may be used to changed kernel settings
757 prepareenv
758 entershell
759 ;;
760 clean)
761 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
762 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
763 $LOSETUP -d $i 2>/dev/null
764 done
765 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
766 umount $i
767 done
768 stdumount
769 for i in `seq 0 7`; do
770 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
771 umount /dev/loop${i} 2>/dev/null;
772 losetup -d /dev/loop${i} 2>/dev/null;
773 fi;
774 done
775 rm -rf $BASEDIR/build
776 rm -rf $BASEDIR/cdrom
777 rm -rf $BASEDIR/packages
778 rm -rf $BASEDIR/log
779 if [ -h /tools ]; then
780 rm -f /tools
781 fi
782 beautify message DONE
783 ;;
784 downloadsrc)
785 if [ ! -d $BASEDIR/cache ]; then
786 mkdir $BASEDIR/cache
787 fi
788 mkdir -p $BASEDIR/log
789 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
790 FINISHED=0
791 cd $BASEDIR/lfs
792 for c in `seq $MAX_RETRIES`; do
793 if (( FINISHED==1 )); then
794 break
795 fi
796 FINISHED=1
797 cd $BASEDIR/lfs
798 for i in *; do
799 if [ -f "$i" -a "$i" != "Config" ]; then
800 echo -ne "Loading $i"
801 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
802 if [ $? -ne 0 ]; then
803 beautify message FAIL
804 FINISHED=0
805 else
806 if [ $c -eq 1 ]; then
807 beautify message DONE
808 fi
809 fi
810 fi
811 done
812 done
813 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
814 ERROR=0
815 for i in *; do
816 if [ -f "$i" -a "$i" != "Config" ]; then
817 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
818 if [ $? -ne 0 ]; then
819 echo -ne "MD5 difference in lfs/$i"
820 beautify message FAIL
821 ERROR=1
822 fi
823 fi
824 done
825 if [ $ERROR -eq 0 ]; then
826 echo -ne "${BOLD}all files md5sum match${NORMAL}"
827 beautify message DONE
828 else
829 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
830 beautify message FAIL
831 fi
832 cd - >/dev/null 2>&1
833 ;;
834 toolchain)
835 clear
836 prepareenv
837 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
838 buildtoolchain
839 BUILDMACHINE=`uname -m`
840 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
841 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
842 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
843 build/{bin,etc,usr/bin,usr/local} \
844 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
845 log >> $LOGFILE
846 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
847 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
848 stdumount
849 ;;
850 gettoolchain)
851 BUILDMACHINE=`uname -m`
852 # arbitrary name to be updated in case of new toolchain package upload
853 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
854 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
855 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
856 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
857 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
858 cd $BASEDIR/cache/toolchains
859 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
860 if [ $? -ne 0 ]; then
861 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
862 else
863 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
864 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
865 else
866 exiterror "$PACKAGE.md5 did not match, check downloaded package"
867 fi
868 fi
869 else
870 echo "Toolchain is already downloaded. Exiting..."
871 fi
872 ;;
873 othersrc)
874 prepareenv
875 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
876 chroot $LFS /tools/bin/env -i HOME=/root \
877 TERM=$TERM PS1='\u:\w\$ ' \
878 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
879 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
880 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
881 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
882 if [ $? -eq "0" ]; then
883 beautify message DONE
884 else
885 beautify message FAIL
886 fi
887 stdumount
888 ;;
889 git)
890 case "$2" in
891 update|up)
892 git pull
893 ;;
894 commit|ci)
895 shift 2
896 git commit $*
897
898 [ "$?" -eq "0" ] || exiterror "git commit $* failed."
899
900 echo -e "${BOLD}Do you want to push, too? [y/N]${NORMAL}"
901 read
902 [ -z $REPLY ] && exit 0
903 for i in y Y j J; do
904 if [ "$i" == "$REPLY" ]; then
905 $0 git push
906 exit $?
907 fi
908 done
909 exiterror "\"$REPLY\" is not a valid answer."
910 ;;
911 dist)
912 git archive HEAD | gzip -9 > ${SNAME}-${VERSION}.tar.gz
913 ;;
914 diff|di)
915 echo -ne "Make a local diff to last revision"
916 git diff HEAD > ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff
917 evaluate 1
918 echo "Diff was successfully saved to ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff"
919 git diff --stat
920 ;;
921 push)
922 [ -z $GIT_USER ] && exiterror "You have to setup GIT_USER first."
923 GIT_URL="ssh://${GIT_USER}@git.ipfire.org/pub/git/ipfire-2.x"
924
925 git push ${GIT_URL} ${GIT_BRANCH}
926 ;;
927 log)
928 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
929 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
930
931 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
932 ;;
933 esac
934 ;;
935 uploadsrc)
936 PWD=`pwd`
937 cd $BASEDIR/cache/
938 echo -e "Uploading cache to ftp server:"
939 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
940 for i in *; do
941 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
942 grep -q $(basename $i) /tmp/ftplist
943 if [ "$?" -ne "0" ]; then
944 echo -ne "$(basename $i)"
945 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
946 if [ "$?" -ne "0" ]; then
947 beautify message FAIL
948 fi
949 fi
950 done
951 rm -f /tmp/ftplist
952 cd $PWD
953 exit 0
954 ;;
955 upload)
956 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
957 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
958 if [ -z $FTP_ISO_PORT ]; then
959 FTP_ISO_PORT=21
960 fi
961 cat <<EOF > .ftp-commands
962 mkdir -p $FTP_ISO_PATH$SVN_REVISION
963 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
964 quit
965 EOF
966 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
967 rm -f .ftp-commands
968
969 case "$2" in
970 iso)
971 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
972
973 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
974 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
975 if [ -e "$i" ]; then
976 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
977 if [ "$?" -eq "0" ]; then
978 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
979 else
980 echo "There was an error while uploading the file $i to the ftp server."
981 exit 1
982 fi
983 fi
984 done
985 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
986 if [ "$3" = "--with-sources-cd" ]; then
987 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
988 fi
989 ;;
990 paks)
991 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
992 if [ "$?" -eq "0" ]; then
993 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
994 else
995 echo -e "There was an error while uploading the packages to the ftp server."
996 exit 1
997 fi
998 ;;
999 esac
1000 ;;
1001 batch)
1002 if [ "$2" = "--background" ]; then
1003 batch_script
1004 exit $?
1005 fi
1006 if [ `screen -ls | grep -q ipfire` ]; then
1007 echo "Build is already running, sorry!"
1008 exit 1
1009 else
1010 if [ "$2" = "--rebuild" ]; then
1011 export IPFIRE_REBUILD=1
1012 echo "REBUILD!"
1013 else
1014 export IPFIRE_REBUILD=0
1015 fi
1016 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1017 screen -dmS ipfire $0 batch --background
1018 evaluate 1
1019 exit 0
1020 fi
1021 ;;
1022 watch)
1023 watch_screen
1024 ;;
1025 pxe)
1026 case "$2" in
1027 start)
1028 start_tftpd
1029 ;;
1030 stop)
1031 stop_tftpd
1032 ;;
1033 reload|restart)
1034 reload_tftpd
1035 ;;
1036 esac
1037 exit 0
1038 ;;
1039 lang)
1040 update_langs
1041 ;;
1042 "")
1043 clear
1044 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "LOG: Tail" "Help"
1045 do
1046 case $name in
1047 "IPFIRE: Downloadsrc")
1048 $0 downloadsrc
1049 ;;
1050 "IPFIRE: Build (silent)")
1051 $0 build-silent
1052 ;;
1053 "IPFIRE: Watch Build")
1054 $0 watch
1055 ;;
1056 "IPFIRE: Batch")
1057 $0 batch
1058 ;;
1059 "IPFIRE: Clean")
1060 $0 clean
1061 ;;
1062 "Help")
1063 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1064 cat doc/make.sh-usage
1065 ;;
1066 "LOG: Tail")
1067 tail -f log/_*
1068 ;;
1069 "Exit")
1070 break
1071 ;;
1072 esac
1073 done
1074 ;;
1075 config)
1076 make_config
1077 ;;
1078 *)
1079 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1080 cat doc/make.sh-usage
1081 ;;
1082 esac